# Class TransformerException

java.lang.Object
java.lang.Throwable
java.lang.Exception
javax.xml.transform.TransformerException

All Implemented Interfaces:
  `Serializable`

Direct Known Subclasses:
  `TransformerConfigurationException`

public class TransformerException extends Exception
This class specifies an exceptional condition that occurred during the transformation process.

Since:
  1.4
See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`TransformerException(String message)`
Create a new TransformerException.
`TransformerException(String message, Throwable e)`
Wrap an existing exception in a TransformerException.
`TransformerException(String message, SourceLocator locator)`
Create a new TransformerException from a message and a Locator.
`TransformerException(String message, SourceLocator locator, Throwable e)`
Wrap an existing exception in a TransformerException.
`TransformerException(Throwable e)`
Create a new TransformerException wrapping an existing exception.

## Method Summary

Modifier and Type
Method
Description
`Throwable`
`getCause()`
Returns the cause of this throwable or `null` if the cause is nonexistent or unknown.
`Throwable`
`getException()`
This method retrieves an exception that this exception wraps.
`String`
`getLocationAsString()`
Get the location information as a string.
`SourceLocator`
`getLocator()`
Method getLocator retrieves an instance of a SourceLocator object that specifies where an error occurred.
`String`
`getMessageAndLocation()`
Get the error message with location information appended.
`Throwable`
`initCause(Throwable cause)`
Initializes the cause of this throwable to the specified value.
`void`
`printStackTrace()`
Print the trace of methods from where the error originated.
`void`
`printStackTrace(PrintStream s)`
Print the trace of methods from where the error originated.
`void`
`printStackTrace(PrintWriter s)`
Print the trace of methods from where the error originated.
`void`
`setLocator(SourceLocator location)`
Method setLocator sets an instance of a SourceLocator object that specifies where an error occurred.

### Methods declared in class Throwable

`addSuppressed, fillInStackTrace, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, setStackTrace, toString`
Modifier and Type
Method
Description
`final void`
`addSuppressed(Throwable exception)`
Appends the specified exception to the exceptions that were suppressed in order to deliver this exception.
`Throwable`
`fillInStackTrace()`
Fills in the execution stack trace.
`String`
`getLocalizedMessage()`
Creates a localized description of this throwable.
`String`
`getMessage()`
Returns the detail message string of this throwable.
`StackTraceElement[]`
`getStackTrace()`
Provides programmatic access to the stack trace information printed by `Throwable.printStackTrace()`.
`final Throwable[]`
`getSuppressed()`
Returns an array containing all of the exceptions that were suppressed, typically by the `try`-with-resources statement, in order to deliver this exception.
`void`
`setStackTrace(StackTraceElement[] stackTrace)`
Sets the stack trace elements that will be returned by `Throwable.getStackTrace()` and printed by `Throwable.printStackTrace()` and related methods.
`String`
`toString()`
Returns a short description of this throwable.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### TransformerException

public TransformerException(String message)
Create a new TransformerException.

Parameters:
  `message` - The error or warning message.

### TransformerException

public TransformerException(Throwable e)
Create a new TransformerException wrapping an existing exception.

Parameters:
  `e` - The exception to be wrapped.

### TransformerException

public TransformerException(String message, Throwable e)
Wrap an existing exception in a TransformerException.

This is used for throwing processor exceptions before the processing has started.

Parameters:
  `message` - The error or warning message, or null to use the message from the embedded exception.
  `e` - Any exception

### TransformerException

public TransformerException(String message, SourceLocator locator)
Create a new TransformerException from a message and a Locator.

This constructor is especially useful when an application is creating its own exception from within a DocumentHandler callback.

Parameters:
  `message` - The error or warning message.
  `locator` - The locator object for the error or warning.

### TransformerException

public TransformerException(String message, SourceLocator locator, Throwable e)
Wrap an existing exception in a TransformerException.

Parameters:
  `message` - The error or warning message, or null to use the message from the embedded exception.
  `locator` - The locator object for the error or warning.
  `e` - Any exception

## Method Details

### getLocator

public SourceLocator getLocator()
Method getLocator retrieves an instance of a SourceLocator object that specifies where an error occurred.

Returns:
  A SourceLocator object, or null if none was specified.

### setLocator

public void setLocator(SourceLocator location)
Method setLocator sets an instance of a SourceLocator object that specifies where an error occurred.

Parameters:
  `location` - A SourceLocator object, or null to clear the location.

### getException

public Throwable getException()
This method retrieves an exception that this exception wraps.

Returns:
  An Throwable object, or null.
See Also:
  - `getCause()`

### getCause

public Throwable getCause()
Returns the cause of this throwable or `null` if the cause is nonexistent or unknown. (The cause is the throwable that caused this throwable to get thrown.)

Overrides:
  `getCause` in class `Throwable`
Returns:
  the cause, or null if unknown

### initCause

public Throwable initCause(Throwable cause)
Initializes the cause of this throwable to the specified value. (The cause is the throwable that caused this throwable to get thrown.)

This method can be called at most once. It is generally called from within the constructor, or immediately after creating the throwable. If this throwable was created with `TransformerException(Throwable)` or `TransformerException(String,Throwable)`, this method cannot be called even once.

Overrides:
  `initCause` in class `Throwable`
Parameters:
  `cause` - the cause (which is saved for later retrieval by the `getCause()` method). (A `null` value is permitted, and indicates that the cause is nonexistent or unknown.)
Returns:
  a reference to this `Throwable` instance.
Throws:
  `IllegalArgumentException` - if `cause` is this throwable. (A throwable cannot be its own cause.)
  `IllegalStateException` - if this throwable was created with `TransformerException(Throwable)` or `TransformerException(String,Throwable)`, or this method has already been called on this throwable.

### getMessageAndLocation

public String getMessageAndLocation()
Get the error message with location information appended.

Returns:
  A `String` representing the error message with location information appended.

### getLocationAsString

public String getLocationAsString()
Get the location information as a string.

Returns:
  A string with location info, or null if there is no location information.

### printStackTrace

public void printStackTrace()
Print the trace of methods from where the error originated. This will trace all nested exception objects, as well as this object.

Overrides:
  `printStackTrace` in class `Throwable`

### printStackTrace

public void printStackTrace(PrintStream s)
Print the trace of methods from where the error originated. This will trace all nested exception objects, as well as this object.

Overrides:
  `printStackTrace` in class `Throwable`
Parameters:
  `s` - The stream where the dump will be sent to.

### printStackTrace

public void printStackTrace(PrintWriter s)
Print the trace of methods from where the error originated. This will trace all nested exception objects, as well as this object.

Overrides:
  `printStackTrace` in class `Throwable`
Parameters:
  `s` - The writer where the dump will be sent to.